#include <iostream>
#include <climits>
#define MaxN 200000

using namespace std;

int main()
{
    long long n;
    bool d=true, e=true;
    cin>>n;
    int a[MaxN], f[MaxN];
    for(int i=1; i<=n; i++)
    {
        cin>>a[i];
        f[i]=a[i];
    }
    long long Q;
    cin>>Q;
    int l[Q], r[Q], t[Q]{}, b[Q];
    for(int i=1; i<=Q; i++)
    {
        cin>>l[i]>>r[i];
        for(int j=l[i]; j<r[i]; j++)
        {
            if(a[j]>a[j+1])
            {
                t[i]++;
                b[i]=j;
            }
        }
        if(l[i]==r[i])
            t[i]=0;
    }
    for(int i=1; i<=Q; i++)
    {
        if(t[i]==0)
            cout<<"DA"<<endl;
        else if(t[i]>=2)
            cout<<"NE"<<endl;
        else
        {
            if(b[i]-1>=l[i])
                a[b[i]]=a[b[i]-1];
            else a[b[i]]=INT_MIN;
            for(int j=l[i]; j<r[i]; j++)
            {
                if(a[j]>a[j+1])
                {
                    d=false;
                }
            }
            for(int j=1; j<=n; j++)
                a[j]=f[j];
            if(b[i]>=l[i])
                f[b[i]+1]=f[b[i]];
            else f[b[i]]=INT_MIN;
            for(int j=l[i]; j<r[i]; j++)
            {
                if(f[j]>f[j+1])
                {
                    e=false;
                }
            }
            for(int j=1; j<=n; j++)
                f[j]=a[j];
            if(d==false && e==false)
                cout<<"NE"<<endl;
            else cout<<"DA"<<endl;
            d=true;
        }
    }
}